package de.uni_marburg.powersort.FinnSort;

import org.mockito.invocation.InvocationOnMock;
import org.mockito.stubbing.Answer;

import java.util.ArrayList;
import java.util.List;


/**
 * Source: https://stackoverflow.com/a/25694142/6334421
 * <p>
 * Alternative which didn't work: https://github.com/mockito/mockito/issues/2422
 */
public class ResultCaptor<T> implements Answer {
    private final List<T> results = new ArrayList<>();

    /**
     * Returns all captured values.
     */
    public List<T> getAllValues() {
        return results;
    }

    @Override
    public T answer(InvocationOnMock invocationOnMock) throws Throwable {
        T result = (T) invocationOnMock.callRealMethod();
        results.add(result);
        return result;
    }
}
