package de.uni_marburg.powersort.MSort;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.stream.Collectors;
import java.util.stream.IntStream;

import de.uni_marburg.powersort.benchmark.NaturalOrder;
import org.junit.jupiter.api.Test;

//import static de.uni_marburg.powersort.MSort.IMPL_M_3.MERGE_COST;
import static de.uni_marburg.powersort.MSort.IMPL_M_3.fillWithAscRunsHighToLow;
import static de.uni_marburg.powersort.MSort.IMPL_M_3.powerSort;

class PowerSortTest {
    @Test
    public void testWithOneInputList() {
       // List<Integer> list = new ArrayList<>(List.of(5, 2, 8, 12, 1, 6));
       // extendRun(list, 0);
        //System.out.println(list);
        // example from slides he wrote this
        // int[] runs = {5, 3, 3, 14, 1, 2};
       int []  runs = new int[]{9, 16, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7};
       int totalSize = Arrays.stream(runs).sum();

       Integer[] a = new Integer[totalSize];

       System.out.println();
       fillWithAscRunsHighToLow(a, runs, 1);
       //MERGE_COST = 0;
       System.out.println("Sorting with Powersort:");
       powerSort(a,NaturalOrder.INSTANCE);
       System.out.println("Sorted Array"+Arrays.toString(a));
      // System.out.println("Merge cost: " + MERGE_COST);
    }

    @Test
    public void testWithFinnInputList() {
        Integer [] numbers = new Integer[] {24, 25, 26, 27, 28, 21, 22, 23, 18, 19, 20, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 3, 1, 2};

        System.out.println("Original array"+Arrays.toString(numbers));
       powerSort(numbers, NaturalOrder.INSTANCE);
        System.out.println("Result: "+Arrays.toString(numbers));
      // System.out.println(new ArrayList<>(List.of(numbers)));
    }
}
